unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type
  TANode = OBJECT
    A:integer;
    Data:array[1..5,1..10] of char;
    Dat:array[1..5] of char;
  end;


  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    Button6: TButton;
    Button7: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure AsmCharCopy(const Source; const Dest; Count : Integer);
asm
  cmp   ECX,0
  Je    @ExitProc
  push  ESI
  push  EDI
  mov   EAX,Source
  mov   ESI, [EAX] 
  mov   EDI, EDX
  @StartCopyChar:
     Mov  AL, [ESI]
     Inc  ESI
     mov  [EDI], AL
     Inc  EDI
     Dec  ECX
     Jnz  @StartCopyChar
  pop   EDI
  pop   ESI
  @ExitProc:
end;

procedure AsmFillChar(const TheChar;const Dest; Count : Integer);
asm
  cmp   ECX,0
  Je    @ExitProc
  push  ESI
  push  EDI
  mov   EAX,TheChar
  mov   ESI, [EAX]
  mov   EDI, EDX
  Mov   AL, [ESI]
  @StartFillChar:
     mov  [EDI], AL
     Inc  EDI
     Dec  ECX
     Jnz  @StartFillChar
  pop   EDI
  pop   ESI
  @ExitProc:
end;

procedure AsmOBJArrayFillChar(const TheChar;Dest:TANode;count:integer);
asm
  cmp   ECX,0
  Je    @ExitProc
  push  ESI
  push  EDI
  push  EBX
  push  EDX

  mov   EAX,TheChar
  mov   ESI,EAX
  mov   AL, [ESI]
  mov   EBX,count
  mov   ECX,0
  @StartFillChar:
     //PoolΪk: mov  [offset Dest.Data[ECX]], AL
     push EBX
     lea  EBX,Dest.Dat[ECX]
     mov  [EBX],AL
     pop  EBX

     inc  ECX
     cmp  ECX,EBX
     Js   @StartFillChar

  pop  EDX   
  pop  EBX
  pop  EDI
  pop  ESI
  @ExitProc:
end;

procedure AsmOBJ2DArrayFillChar(const TheChar;Dest:TANode;PageNo,count:integer);
asm
  push  ESI
  push  EDI
  push  EBX
  push  ESI
  
  mov   EAX,TheChar
  mov   ESI,EAX
  mov   ECX,PageNo
  dec   ECX
  mov   EAX,0

  @GetArrayStartIndex:
     cmp ECX,0
     je  @PrepareFillchar
     add EAX,count
     dec ECX
     cmp ECX,0
     jne @GetArrayStartIndex

  @PrepareFillchar:
     mov   EBX,EAX
     mov   ECX,0
     mov   AL, [ESI]
     
  @StartFillChar:
     //PoolΪk: mov  [offset [offset Dest.Data[EBX]] ],AL
     push EBX
     lea  EBX,Dest.Data[EBX]
     mov  [EBX],AL
     pop  EBX
     
     inc  EBX
     inc  ECX
     cmp  ECX,count
     Js   @StartFillChar

  pop  ESI
  pop  EBX
  pop  EDI
  pop  ESI
  @ExitProc:
end;


procedure AsmOBJ2DArrayCharCopy(const Source;Dest:TANode;
                                PageNo,PageLength,StrLength,CopyCount:integer);
asm
  push  ESI
  push  EDI
  push  EBX
  push  ESI

  mov   EAX,Source
  mov   ESI,[EAX]

  mov   ECX,PageNo
  dec   ECX
  mov   EAX,0

  @GetArrayStartIndex:
     cmp ECX,0
     je  @PrepareFillchar
     add EAX,PageLength
     dec ECX
     cmp ECX,0
     jne @GetArrayStartIndex

  @PrepareFillchar:
     mov   EBX,EAX
     mov   ECX,0
  @StartFillChar:
     mov  AL,[ESI]
     //PoolΪk: mov  [offset [offset Dest.Data[EBX]] ],AL
     push EBX
     lea  EBX,Dest.Data[EBX]
     mov  [EBX],AL
     pop  EBX
     
     inc  EBX
     inc  ECX
     inc  ESI
     cmp  ECX,CopyCount
     Js   @StartFillChar

  pop  ESI
  pop  EBX
  pop  EDI
  pop  ESI
  @ExitProc:
end;

type
  AsmResultStr = array[1..10] of Char;

function AsmGetArrayStr(const TheChar;Count:integer):AsmResultStr;
asm
  push  ESI
  push  EDI
  mov   EAX,TheChar
  mov   ESI,EAX
  mov   EDI,@Result
  mov   ECX,Count
  @StartGetChar:
     Mov  AL, [ESI]
     mov  [EDI], AL
     Inc  ESI
     Inc  EDI
     Dec  ECX
     Jnz  @StartGetChar
  pop   EDI
  pop   ESI
  @ExitProc:
end;

type
  AsmPageStr = array[1..10] of Char;
  
function AsmGetPageStrFromString(PageNo,PageSize:integer;const InStr):AsmPageStr;
asm
  push  ESI
  push  EDI
  push  EBX
  mov   EBX,PageNo          
  mov   EAX,InStr
  mov   ESI,EAX
  mov   EDI,@Result
  mov   ECX,PageSize
  cmp   EBX,1
  je    @StartGetChar
  //YPageNo <> 1,ʦrӷ
  mov   EAX,ECX
  dec   EBX
  imul  EBX
  mov   EBX,EAX
  @MoveCharCursor:
     Inc ESI
     dec EAX
     cmp EAX,0
     jne @MoveCharCursor
  @StartGetChar:
     mov   AL,[ESI]
     mov   [EDI], AL
     Inc   ESI
     Inc   EDI
     Dec   ECX
     Jnz   @StartGetChar
  pop   EBX
  pop   EDI
  pop   ESI
  @ExitProc:
end;

procedure TForm1.Button1Click(Sender: TObject);
var AA:string;
    bb:array[1..5,1..255] of char;
begin
  AA := 'A1234567890123456789'
       +'B1234567890123456789'
       +'C1234567890123456789'
       +'D1234567890123456789'
       +'E1234567890123456789'
       +'F1234567890123456789'
       +'G1234567890123456789'
       +'H1234567890123456789'
       +'I1234567890123456789'
       +'J1234567890123456789'
       +'K1234567890123456789'
       +'L1234567890123456789'
       +'M1234567890123Z';
  AsmCharCopy(AA,bb[1],255);
  ShowMessage(bb[1]);

end;

procedure TForm1.Button2Click(Sender: TObject);
var AA:string;
    bb:array[1..5,1..255] of char;
begin
  AA := '?';
  AsmFillChar(AA,bb[1],255);
  ShowMessage(bb[1]);
end;

procedure TForm1.Button3Click(Sender: TObject);
const XXX = 'BBBFFFGGG';
var ss:string;
begin
  ss := AsmGetArrayStr('ABC',3);
  ShowMessage(ss);

  ss := AsmGetArrayStr(XXX,3);
  ShowMessage(ss);
end;

procedure TForm1.Button4Click(Sender: TObject);
const AAA = '1XXXX2YYYY3ZZZZ4PPPP';
var ss:string;
begin
  ss := AsmGetPageStrFromString(1,5,AAA);
  ShowMessage(ss);

  ss := AsmGetPageStrFromString(2,5,AAA);
  ShowMessage(ss);

  ss := AsmGetPageStrFromString(3,5,AAA);
  ShowMessage(ss);

  ss := AsmGetPageStrFromString(4,5,AAA);
  ShowMessage(ss);
end;

type
  TKK = Object
    A,b:integer;
    s:array[1..3] of char;
  end;

function Sum(xx,yy:TKK): Integer; stdcall;
asm
  //
  mov EDI,offset xx.s
end;

procedure TForm1.Button5Click(Sender: TObject);
var mm:TANode;
    bb,ff:string;
    AB:char;
    procedure doTest(PageNo:integer);
    begin
      bb := AsmGetArrayStr(mm.Data[PageNo],10);
      AsmOBJ2DArrayFillChar(AB,mm,PageNo,10);
      ff := AsmGetArrayStr(mm.Data[PageNo],10);
      ShowMessage( 'Before Clear : '+bb
                  +#10#13
                  +'After Clear : '+ff);
    end;
begin
  AB := 'X';
  mm.A := 8;
  mm.Dat[1] := 'A';
  mm.Data[1, 1] := 'A';  mm.Data[2, 1] := 'B';  mm.Data[3, 1] := 'C';
  mm.Data[1, 2] := '0';  mm.Data[2, 2] := '0';  mm.Data[3, 2] := '0';
  mm.Data[1, 3] := '0';  mm.Data[2, 3] := '0';  mm.Data[3, 3] := '0';
  mm.Data[1, 4] := '0';  mm.Data[2, 4] := '0';  mm.Data[3, 4] := '0';
  mm.Data[1, 5] := '0';  mm.Data[2, 5] := '0';  mm.Data[3, 5] := '0';
  mm.Data[1, 6] := '0';  mm.Data[2, 6] := '0';  mm.Data[3, 6] := '0';
  mm.Data[1, 7] := '0';  mm.Data[2, 7] := '0';  mm.Data[3, 7] := '0';
  mm.Data[1, 8] := '0';  mm.Data[2, 8] := '0';  mm.Data[3, 8] := '0';
  mm.Data[1, 9] := '0';  mm.Data[2, 9] := '0';  mm.Data[3, 9] := '0';
  mm.Data[1,10] := '0';  mm.Data[2,10] := '0';  mm.Data[3,10] := '0';

  doTest(1);
  doTest(2);
  doTest(3);

end;

procedure TForm1.Button6Click(Sender: TObject);
var mm:TANode;
    bb,ff:string;
    procedure doTest(instr:string;PageNo,count:integer);
    begin
      bb := AsmGetArrayStr(mm.Data[PageNo],count);
      AsmOBJ2DArrayCharCopy(instr,mm,PageNo,10,Length(instr),count);
      ff := AsmGetArrayStr(mm.Data[PageNo],count);
      ShowMessage( 'Before Clear : '+bb
                  +#10#13
                  +'After Clear : '+ff);
    end;
begin
  mm.A := 8;
  mm.Dat[1] := 'A';
  mm.Data[1, 1] := 'A';  mm.Data[2, 1] := 'B';  mm.Data[3, 1] := 'C';
  mm.Data[1, 2] := '0';  mm.Data[2, 2] := '0';  mm.Data[3, 2] := '0';
  mm.Data[1, 3] := '0';  mm.Data[2, 3] := '0';  mm.Data[3, 3] := '0';
  mm.Data[1, 4] := '0';  mm.Data[2, 4] := '0';  mm.Data[3, 4] := '0';
  mm.Data[1, 5] := '0';  mm.Data[2, 5] := '0';  mm.Data[3, 5] := '0';
  mm.Data[1, 6] := '0';  mm.Data[2, 6] := '0';  mm.Data[3, 6] := '0';
  mm.Data[1, 7] := '0';  mm.Data[2, 7] := '0';  mm.Data[3, 7] := '0';
  mm.Data[1, 8] := '0';  mm.Data[2, 8] := '0';  mm.Data[3, 8] := '0';
  mm.Data[1, 9] := '0';  mm.Data[2, 9] := '0';  mm.Data[3, 9] := '0';
  mm.Data[1,10] := '0';  mm.Data[2,10] := '0';  mm.Data[3,10] := '0';

  //doTest('ABCDEFGHI1',1,5);
  //doTest('ABCDEXGHI2',2,3);
  doTest('AKCDE',3,10);

end;


procedure TForm1.Button7Click(Sender: TObject);
var bb:TANode;
    AA:char;
begin
  AA := 'X';
  AsmOBJArrayFillChar(AA,bb,5);
  ShowMessage('bb.Dat = '''+bb.Dat+'''');
end;

end.
